grammar Language4_infix;

 expression : exp EOF
            ;

        exp :  begin | var | abexp
            ;

      begin : '{' exp ( ';' exp )* '}' /* why do we need the ';' ??? */
            ;

        var : VARIABLE '=' exp
            ;

      abexp : abterm ( '||' abterm )*
            ;

     abterm : efactor ( '&&' efactor )*
            ;

    efactor : rfactor ( '==' rfactor | '!=' rfactor )*
            ;

    rfactor : aexp ( relOp  aexp )?
            ;

      relOp : '<' | '>' | '<=' | '>='
            ;

       aexp : term ( '+' term | '-' term )*
            ;

       term : signed ( '*' signed | '/' signed | '%' signed )*
            ;

     signed : ( '-' | '+' | '!' )? factor
            ;

     factor : base ( '^' signed )?
            ;

       base : '(' abexp ')'
            | INTEGER
            | BOOLEAN
            | VARIABLE
            ;

    INTEGER : '0'..'9'+
            ;

    BOOLEAN : 'false' | 'true'
            ;

   VARIABLE : ('a'..'z')+
            ;

         WS : (' '|'\t'|'\n'|'\r')+ {skip();}
            ;
