/*
  This program tests the lexers and parsers created
  by Antlr from the grammars Language4_infix_AST.g.

  See the following page for information on using Antlr
  on the command line to create the lexer and parser, to
  compile the lexer and parser, and then to compile and
  run this program.
  http://www.antlr.org/wiki/pages/viewpage.action?pageId=729
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestParser_AST
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
        "{{x=2; y=2}; z= x+y}",
        "{x=4; {y=false; y||2+x==2*3}}",
        "{x={z=2; z+z}; {y=false; {u=2; {v=y||u+4==u*3; v}}}}",
        "x={y=2; z=y+3}",
        // illegal expressions
        "z = (x = y = 2) + (y + 3 * x)",
        "{x = false; 1 + x}",
        "(2 * 2 != 5) + 1 / 0"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         Language4_infix_ASTLexer lexer = new Language4_infix_ASTLexer(new ANTLRStringStream(exprs[i]));
         Language4_infix_ASTParser parser = new Language4_infix_ASTParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is a String and a CommonTree.
            // (See the source code Language4_infix_ASTParser.java and
            // look for the inner class "expression_return".)
            Language4_infix_ASTParser.expression_return r = parser.expression();
            String s = r.result;
            System.out.println( s );
            CommonTree tree = (CommonTree)r.getTree();
            System.out.println( tree.toStringTree() );
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println();
      }
   }//main

}//TestParser_AST
